package tcbnet.control;

import tcbnet.corba.Header;
import java.util.Enumeration;

/**
 * Filtro agrupamento de filtros. Eh verdadeiro se e somente se todos os seus
 * filtros componentes forem verdadeiros.
 *
 * @author $Author: fabipiesigilli $
 * @version $Revision: 1.6 $
 */

public class FilterAnd
    extends FilterGroup
{
    /**
     * Dado um header, retorna se passou por todos os filtros da lista.
     *
     * @param h header a ser avaliado
     * @return se o arquivo representado pelo cabecalho passa pelo filtro
     */
    public synchronized boolean passFilter(Header header) {
	Enumeration i = this.children();
	Filter f;
	while (i.hasMoreElements()) {
	    f = (Filter) i.nextElement();
	    if (! f.passFilter(header)) return false;
	}
	return true;
    }

    /**
     * Retorna uma representacao do filtro no formato de texto.
     *
     * @return nome do no
     */
    public synchronized String toString() {
	return "And";
    }
    /*
    public Object clone() {
	Object copy = super.clone();
	DefaultMutableTreeNode f = (DefaultMutableTreeNode) getChildAt(0);
	copy.add ((DefaultMutableTreeNode)f.clone());
	return copy;
	}*/
}

