package tcbnet.control;

import tcbnet.corba.Header;
import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 * Classe abstrata que implementa metodos para lidar com um filtro conector
 * (apenas um filho).
 *
 * @author $Author: fabipiesigilli $
 * @version $Revision: 1.13 $
 */

public class FilterConnector
    extends DefaultMutableTreeNode
    implements Filter
{

    public boolean passFilter (Header h) { return true; }

    /**
     * Insere o node newChild com indice childIndex  
     *
     * @param h header a ser avaliado
     * @return se o arquivo representado pelo cabecalho passa pelo filtro
     */
    public void insert(MutableTreeNode newChild, int childIndex) {
	if (getChildCount() > 0) return;
	super.insert (newChild, childIndex);
    }

    public Object clone() {
	Object copy = null;
	copy = super.clone();
	if (getChildCount() > 0) {
	    DefaultMutableTreeNode f = (DefaultMutableTreeNode) getChildAt(0);
	    ((FilterConnector)copy).add ((DefaultMutableTreeNode)f.clone());
	}
	return copy;
    }

}
