package tcbnet.control;

import tcbnet.corba.Header;

/**
 * Filtro de negacao (inverte o resultado do filtro conectado).
 *
 * @author $Author: dseki $
 * @version $Revision: 1.4 $
 */

public class FilterNot
    extends FilterConnector
{
    /**
     * Dado um header, decide se ele passa no filtro ou nao.
     * Por definicao, se nao houver filtro anexo, NADA passa pelo filtro.
     *
     * @param  h head a ser avaliado
     * @return se o arquivo representado pelo cabecalho deve ser salvo ou nao
     */
    public synchronized boolean passFilter(Header h)
    {
	Filter f = (Filter) getChildAt(0);
	if (f == null) return false;
	return !f.passFilter(h);
    }

    /**
     * Retorna uma representacao do filtro no formato de texto.
     *
     * @return representacao no formato texto do filtro
     */
    public String toString()
    {
	return "Not";
    }
}
