package tcbnet.control;

import tcbnet.corba.Header;
import java.util.Enumeration;

/**
 * Filtro agrupamento de filtros. Eh verdadeiro se e somente pelo menos um de
 * seus filtros componentes forem verdadeiros.
 *
 * @author $Author: dseki $
 * @version $Revision: 1.5 $
 */

public class FilterOr
    extends FilterGroup
{
    /**
     * Dado um header, retorna se passou por pelo menos um filtro da lista.
     *
     * @param h header a ser avaliado
     * @return se o arquivo representado pelo cabecalho passa pelo filtro
     */
    public synchronized boolean passFilter(Header header) {
	Enumeration i = this.children();
	Filter f;
	while (i.hasMoreElements()) {
	    f = (Filter) i.nextElement();
	    if (f.passFilter(header)) return true;
	}
	return false;
    }

    /**
     * Retorna uma representacao do filtro no formato de texto.
     *
     * @return representacao no formato texto do filtro
     */
    public synchronized String toString()
    {
	return "Or";
    }
}
