package tcbnet.control;

import tcbnet.corba.Header;

/**
 * Filtro raiz.
 *
 * @author $Author: dseki $
 * @version $Revision: 1.9 $
 */

public class FilterRoot
    extends FilterConnector
{
    /**
     * Dado um header, decide se ele passa no filtro ou nao.
     * Por definicao, se nao houver filtro anexo, TUDO passa pelo filtro.
     *
     * @param  h head a ser avaliado
     * @return se o arquivo representado pelo cabecalho deve ser salvo ou nao
     */
    public synchronized boolean passFilter(Header h)
    {
	Filter f;
	try { f = (Filter) getChildAt(0); }
	catch (ArrayIndexOutOfBoundsException aioobe) { return true; }
	if (f == null) return true;
	return f.passFilter(h);
    }
    
    public String toString() {
	return "Root";
    }
}
