package tcbnet.corba;

import tcbnet.io.FileReader;
import tcbnet.control.*;

/**
 * <p>Title: TCBnet</p>
 * <p>Description: p2p content push</p>
 * <p>Copyright: TCB inc Copyright (c) 2002</p>
 * <p>Company: TCB inc</p>
 * @author $Author: rcouto $
 * @version $Revision: 1.5 $
 */

public class Factory {

  /**
   * Cria um objeto do tipo node
   * @param cfg o bean de configuraao
   * @param filter o filtro do n
   * @return o objeto Node criado
   */
  public static Node createNode(ConfigurationNode cfg) {
    NodeImpl node = new NodeImpl(cfg);
    return TcbnetOrb.getInstance().getNode(node);
  }

  /**
   * Cria um objeto do tipo Stream a partir do nome do arquivo
   * @param fr o arquivo criado para atender o stream
   * @return o objeto do tipo Stream
   */
  public static Stream createStream(FileReader fr) {
    StreamImpl stream = new StreamImpl(fr);
    return TcbnetOrb.getInstance().getStream(stream);
  }
}
