package tcbnet.corba;

import java.io.IOException;
import tcbnet.io.*;

/**
 * <p>Title: TCBnet</p>
 * <p>Description: p2p content push</p>
 * <p>Copyright: TCB inc Copyright (c) 2002</p>
 * <p>Company: TCB inc</p>
 * @author $Author: fernandopeinado $
 * @version $Revision: 1.8 $
 */

public class StreamImpl extends StreamPOA {
    String ior;
    FileReader file;

    public StreamImpl(FileReader in) {
	file = in;
	try {
	    System.out.println(((FileReaderImpl)file).getFileSize());
	} catch (Exception e) { }
    }

    /**
     * L um buffer do stream do tamanho especificado (ou padro) e retorna
     * em um array de bytes
     *
     * @return o buffer lido ou null caso no haja mais nada a ser lido
     * @throws IOErrorException caso ocorra algum erro no processo de leitura
     */
    public int getBuffer(BytesHolder bytes) throws IOErrorException {
        byte[] tmp = null;
	try {
	    tmp = file.readBuffer();
	} catch (IOException e) {
	    throw new IOErrorException();
	}

        if (tmp == null) {
          bytes.value = new byte[1];
          return -1;
        }
        bytes.value = tmp;
	return bytes.value.length;
    }

    /**
     * Devolve a ior, a referencia que identifica o objeto corba.
     * @return ior
     */
    public String getIor() {
	if (this.ior == null) {
	    TcbnetOrb orb = TcbnetOrb.getInstance();
	    ior = orb.getIor(this);
	}
	return ior;
    }
}

