package tcbnet.gui;

/*
 * FiltersWindow.java
 *
 * Created on 29 de Junho de 2002, 15:28
 */

import javax.swing.tree.*;
import tcbnet.control.*;
import java.awt.*;
import javax.swing.tree.DefaultTreeModel;

/**
 *
 * @author  fabi
 * @version 
 */
public class FiltersWindow extends javax.swing.JFrame {

    static String[] filtros = {"AND", "OR", "NOT", "TEXT", "FILE SIZE"};
    final static String TEXTPANEL = "Text Filter Panel";
    final static String EMPTYPANEL = "Empty Panel";
    final static String FILESIZEPANEL = "File Size Panel";
    private TextFilterPanel tfp;
    private FileSizeFilterPanel fsfp;
    private javax.swing.JTree tree;
    private TreePanel treePanel;
    FilterRoot root;
    Configuration conf;
    private javax.swing.tree.DefaultTreeModel model;


    /** Creates new form FiltersWindow */
    public FiltersWindow(Configuration conf) {
	this.root = (FilterRoot) conf.getFilterTree().clone();
	this.conf = conf;
        initComponents ();
        pack ();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents () {//GEN-BEGIN:initComponents
        FilterTreePanel = new javax.swing.JPanel ();
        jPanel3 = new javax.swing.JPanel ();
        FilterChoice = new java.awt.Choice ();

	for (int i = 0; i < filtros.length; i++)
	    FilterChoice.addItem (filtros[i]);

        AddFilterButton = new javax.swing.JButton ();
        RemoveFilterButton = new javax.swing.JButton ();
        EditFilterPanel = new javax.swing.JPanel ();
        getContentPane ().setLayout (new java.awt.GridLayout (1, 2));
        addWindowListener (new java.awt.event.WindowAdapter () {
            public void windowClosing (java.awt.event.WindowEvent evt) {
                exitForm (evt);
            }
        }
        );

        FilterTreePanel.setLayout (new java.awt.BorderLayout ());
    
	jPanel3.add (FilterChoice);
    
	AddFilterButton.setText ("+");
	AddFilterButton.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                    AddFilterButtonActionPerformed (evt);
                }
            }
					   );
    
	jPanel3.add (AddFilterButton);
    
	RemoveFilterButton.setText ("-");
	RemoveFilterButton.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                    RemoveFilterButtonActionPerformed (evt);
                }
            }
					      );
    
	jPanel3.add (RemoveFilterButton);
    
        FilterTreePanel.add (jPanel3, java.awt.BorderLayout.NORTH);
	treePanel = new TreePanel(this, root); 
	tree = treePanel.getTree();
	model = (DefaultTreeModel)tree.getModel();
	FilterTreePanel.add (BorderLayout.CENTER, treePanel);

        getContentPane ().add (FilterTreePanel);

	cardLayout = new java.awt.CardLayout ();

        EditFilterPanel.setLayout (cardLayout);
	
	tfp = new TextFilterPanel(this);
	fsfp = new FileSizeFilterPanel(this);
	EditFilterPanel.add (fsfp, FILESIZEPANEL);
	EditFilterPanel.add (tfp, TEXTPANEL);
	EditFilterPanel.add (new javax.swing.JPanel(), EMPTYPANEL);
	cardLayout.show(EditFilterPanel, EMPTYPANEL);

        getContentPane ().add (EditFilterPanel);

    }//GEN-END:initComponents

  private void RemoveFilterButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RemoveFilterButtonActionPerformed
// Add your handling code here:
      DefaultMutableTreeNode chosen = (DefaultMutableTreeNode)
	  tree.getLastSelectedPathComponent();
      MutableTreeNode parent = (MutableTreeNode)(chosen.getParent()); 
      if (parent != null) {
	  if (javax.swing.JOptionPane.showConfirmDialog (null, "Are you sure you want to remove these filters?",
							 "", javax.swing.JOptionPane.YES_NO_OPTION) != 1) {
	      model.removeNodeFromParent(chosen);
	      return;
	  }
      }
    
  }//GEN-LAST:event_RemoveFilterButtonActionPerformed

  private void AddFilterButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AddFilterButtonActionPerformed
// Add your handling code here:

      DefaultMutableTreeNode child = null, chosen;
      String filtro = FilterChoice.getSelectedItem();
      if (filtro.equals ("AND")) {
	  child = new FilterAnd ();
      }
      else if (filtro.equals ("OR")) {
	  child = new FilterOr ();
      }
      else if (filtro.equals ("NOT")) {
	  child = new FilterNot ();
      }
      else if (filtro.equals ("TEXT")) {
	  child = new FilterText();
      }
      else if (filtro.equals ("FILE SIZE")) {
	  child = new FilterFilesize();
      }
      // What's the last one you clicked?
      chosen = (DefaultMutableTreeNode)
	  tree.getLastSelectedPathComponent();
      if(chosen != null) {
	  model.insertNodeInto(child, chosen, model.getChildCount(chosen));
      }
      if (chosen instanceof FilterConnector)
	  setAdd(false);
    
    
  }//GEN-LAST:event_AddFilterButtonActionPerformed

    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm

	conf.setFilterTree(root);
	dispose();
    }//GEN-LAST:event_exitForm


    void saveTextFilter (String word) {
	DefaultMutableTreeNode chosen = (DefaultMutableTreeNode)
	  tree.getLastSelectedPathComponent();
	if (chosen instanceof FilterText) {
	    ((FilterText)chosen).setWord(word);
	    model.reload();
	}
    }

    void saveFileSizeFilter (long min, long max) {
	DefaultMutableTreeNode chosen = (DefaultMutableTreeNode)
	  tree.getLastSelectedPathComponent();
	if (chosen instanceof FilterFilesize) {
	    ((FilterFilesize)chosen).setMinSize(min);
	    ((FilterFilesize)chosen).setMaxSize(max);
	    model.reload();
	}
    }

    void show (String panel, String text) {
	tfp.setText(text);
	cardLayout.show(EditFilterPanel, panel);
    }

    void show (String panel, long min, long max) {
	fsfp.setText(min/1024, max/1024);
	cardLayout.show(EditFilterPanel, panel);
    }

    void setAdd (boolean tf) {
	AddFilterButton.setEnabled (tf);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel FilterTreePanel;
    private javax.swing.JPanel jPanel3;
    private java.awt.Choice FilterChoice;
    private javax.swing.JButton AddFilterButton;
    private javax.swing.JButton RemoveFilterButton;
    private javax.swing.JPanel EditFilterPanel;
    private java.awt.CardLayout cardLayout;
    // End of variables declaration//GEN-END:variables

}
