package tcbnet.gui;

import tcbnet.control.*;
import tcbnet.ui.*;

/*
 * TCBnet.java
 *
 * Created on 5 de Junho de 2002, 18:42
 */



/**
 *
 * @author $Author: fabipiesigilli $
 * @version $Revision: 1.20 $
 */
public class MainWindow extends javax.swing.JFrame {
        
    AddToQueueWindow addToQueue; 
    FiltersWindow filtersWindow;
    private PushQueue pushQueueModel;
    private Configuration conf;
    private UIController uiController;
    
    /** Creates new form TCBnet */
    public MainWindow(Configuration conf, UIController uiController) {
        super ("TCBnet");
	this.uiController = uiController;
	this.conf = conf;

	pushQueueModel = uiController.getPushQueue();
        initComponents ();
        pack ();
        addToQueue = new AddToQueueWindow(pushQueueModel);
	filtersWindow = new FiltersWindow(conf);
    
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents () {//GEN-BEGIN:initComponents
        MainMenuBar = new javax.swing.JMenuBar ();
        Conections = new javax.swing.JMenu ();
        ConectMenu = new javax.swing.JMenuItem ();
        DisconectMenu = new javax.swing.JMenuItem ();
        jSeparator1 = new javax.swing.JSeparator ();
        P2PConectionsMenu = new javax.swing.JMenuItem ();
        jSeparator2 = new javax.swing.JSeparator ();
        Exit = new javax.swing.JMenuItem ();
        Queue = new javax.swing.JMenu ();
        Add = new javax.swing.JMenuItem ();
        Remove = new javax.swing.JMenuItem ();
        Clear = new javax.swing.JMenuItem ();
        jSeparator3 = new javax.swing.JSeparator ();
        MoveUp = new javax.swing.JMenuItem ();
        MoveDown = new javax.swing.JMenuItem ();
        jSeparator4 = new javax.swing.JSeparator ();
        Edit = new javax.swing.JMenuItem ();
        Configuration = new javax.swing.JMenu ();
        Filters = new javax.swing.JMenu ();
        Help = new javax.swing.JMenu ();
        TransfersPanel = new javax.swing.JPanel ();
        ButtonsPanel = new javax.swing.JPanel ();
        Conect = new javax.swing.JButton ();
        Disconect = new javax.swing.JButton ();
        FiltersButton = new javax.swing.JButton ();
        ConfigurationButton = new javax.swing.JButton ();
        P2PConectionsButton = new javax.swing.JButton ();
        FileTransfersAndTransfersTablePane = new javax.swing.JPanel ();
        FileTransfers = new javax.swing.JLabel ();
        TransfersTableScrollPane = new javax.swing.JScrollPane ();
        TransfersTable = new javax.swing.JTable ();
        QueuesPanel = new javax.swing.JPanel ();
        QueuesButtonsAndLabelPanel = new javax.swing.JPanel ();
        PushQueue = new javax.swing.JLabel ();
        QueuesButtonsPanel = new javax.swing.JPanel ();
        ButtonPlus = new javax.swing.JButton ();
        ButtonLess = new javax.swing.JButton ();
        ButtonUp = new javax.swing.JButton ();
        ButtonDown = new javax.swing.JButton ();
        Editar = new javax.swing.JButton ();
        QueuesTableAndStatisticsPanelPanel = new javax.swing.JPanel ();
        QueuesTableScrollPane = new javax.swing.JScrollPane ();
        QueuesTable = new javax.swing.JTable ();
        StatiscsPanel = new javax.swing.JPanel ();
        TreeConections = new javax.swing.JLabel ();
        P2PConections = new javax.swing.JLabel ();
        DownloadSpeed = new javax.swing.JLabel ();
        UploadSpeed = new javax.swing.JLabel ();

	Conections.setText ("Conections");
	Conections.addActionListener (new java.awt.event.ActionListener () {
		public void actionPerformed (java.awt.event.ActionEvent evt) {
		    ConectionsActionPerformed (evt);
		}
	    }
				      );
  
	ConectMenu.setText ("Conect");
	ConectMenu.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                    ConectMenuActionPerformed (evt);
                }
            }
				      );
    
	Conections.add (ConectMenu);
	DisconectMenu.setText ("Disconect");
	DisconectMenu.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                    DisconectMenuActionPerformed (evt);
                }
            }
					 );
    
	Conections.add (DisconectMenu);
    
	Conections.add (jSeparator1);
	P2PConectionsMenu.setText ("P2P Conections");
    
	Conections.add (P2PConectionsMenu);
    
	Conections.add (jSeparator2);
	Exit.setText ("Exit");
	Exit.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                    ExitActionPerformed (evt);
                }
            }
				);
    
	Conections.add (Exit);
	MainMenuBar.add (Conections);
	Queue.setText ("Queue");
  
	Add.setText ("Add to Queue");
	Add.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                    AddActionPerformed (evt);
                }
            }
			       );
    
	Queue.add (Add);
	Remove.setText ("Remove from Queue");
	Remove.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                    jMenuItem6ActionPerformed (evt);
                }
            }
				  );
    
	Queue.add (Remove);
	Clear.setText ("Clear Queue");
	Clear.setText ("Clear");
	Clear.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                    jMenuItem7ActionPerformed (evt);
                }
            }
				 );
    
	Queue.add (Clear);
    
	Queue.add (jSeparator3);
	MoveUp.setText ("Move Up");
	MoveUp.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                    MoveUpActionPerformed (evt);
                }
            }
				  );
    
	Queue.add (MoveUp);
	MoveDown.setText ("Move Down");
	MoveDown.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                    jMenuItem9ActionPerformed (evt);
                }
            }
				    );
    
	Queue.add (MoveDown);
    
	Queue.add (jSeparator4);
	Edit.setText ("Edit");
	Edit.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                    jMenuItem10ActionPerformed (evt);
                }
            }
				);
    
	Queue.add (Edit);
	MainMenuBar.add (Queue);
	Configuration.setText ("Configuration");
	Configuration.addActionListener (new java.awt.event.ActionListener () {
		public void actionPerformed (java.awt.event.ActionEvent evt) {
		    ConfigurationActionPerformed (evt);
		}
	    }
					 );
  
	MainMenuBar.add (Configuration);
	Filters.setText ("Filters");
	Filters.addActionListener (new java.awt.event.ActionListener () {
		public void actionPerformed (java.awt.event.ActionEvent evt) {
		    jMenu4ActionPerformed (evt);
		}
	    }
				   );
  
	MainMenuBar.add (Filters);
	Help.setText ("Help");
	Help.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
	Help.addActionListener (new java.awt.event.ActionListener () {
		public void actionPerformed (java.awt.event.ActionEvent evt) {
		    HelpActionPerformed (evt);
		}
	    }
				);
  
	MainMenuBar.add (Help);
        getContentPane ().setLayout (new java.awt.GridLayout (2, 1));
        addWindowListener (new java.awt.event.WindowAdapter () {
		public void windowClosing (java.awt.event.WindowEvent evt) {
		    exitForm (evt);
		}
	    }
			   );

        TransfersPanel.setLayout (new java.awt.BorderLayout ());

	ButtonsPanel.setLayout (new java.awt.FlowLayout (1, 15, 15));
  
	Conect.setText ("Conect");
	Conect.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                    jButton3ActionPerformed (evt);
                }
            }
				  );
    
	ButtonsPanel.add (Conect);
    
	Disconect.setText ("Disconect");
	Disconect.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                    jButton4ActionPerformed (evt);
                }
            }
				     );
    
	ButtonsPanel.add (Disconect);
    
	FiltersButton.setText ("Filters");
	FiltersButton.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                    FiltersButtonActionPerformed (evt);
                }
            }
					 );
    
	ButtonsPanel.add (FiltersButton);
    
	ConfigurationButton.setText ("Configuration");
    
	ButtonsPanel.add (ConfigurationButton);
    
	P2PConectionsButton.setText ("P2P Conections");
    
	ButtonsPanel.add (P2PConectionsButton);
    
	TransfersPanel.add (ButtonsPanel, java.awt.BorderLayout.NORTH);
  
	FileTransfersAndTransfersTablePane.setLayout (new java.awt.BorderLayout ());
  
	FileTransfers.setText ("File Transfers");
	FileTransfers.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
    
	FileTransfersAndTransfersTablePane.add (FileTransfers, java.awt.BorderLayout.NORTH);
    
    
	TransfersTable.setModel(uiController.getTransferTableModel());
      
	TransfersTableScrollPane.setViewportView (TransfersTable);
      
	FileTransfersAndTransfersTablePane.add (TransfersTableScrollPane, java.awt.BorderLayout.CENTER);
    
	TransfersPanel.add (FileTransfersAndTransfersTablePane, java.awt.BorderLayout.CENTER);
  

        getContentPane ().add (TransfersPanel);

        QueuesPanel.setLayout (new java.awt.BorderLayout ());

	QueuesButtonsAndLabelPanel.setLayout (new java.awt.GridLayout (1, 2));
  
	PushQueue.setText ("Push Queue");
    
	QueuesButtonsAndLabelPanel.add (PushQueue);
    
    
	ButtonPlus.setText ("+");
	ButtonPlus.addActionListener (new java.awt.event.ActionListener () {
		public void actionPerformed (java.awt.event.ActionEvent evt) {
		    ButtonPlusActionPerformed (evt);
		}
	    }
				      );
      
	QueuesButtonsPanel.add (ButtonPlus);
      
	ButtonLess.setText ("-");
	ButtonLess.addActionListener (new java.awt.event.ActionListener () {
		public void actionPerformed (java.awt.event.ActionEvent evt) {
		    ButtonLessActionPerformed (evt);
		}
	    }
				      );
      
	QueuesButtonsPanel.add (ButtonLess);
      
	ButtonUp.setText ("Up");
	ButtonUp.addActionListener (new java.awt.event.ActionListener () {
		public void actionPerformed (java.awt.event.ActionEvent evt) {
		    ButtonUpActionPerformed (evt);
		}
	    }
				    );
      
	QueuesButtonsPanel.add (ButtonUp);
      
	ButtonDown.setText ("Down");
	ButtonDown.addActionListener (new java.awt.event.ActionListener () {
		public void actionPerformed (java.awt.event.ActionEvent evt) {
		    ButtonDownActionPerformed (evt);
		}
	    }
				      );
      
	QueuesButtonsPanel.add (ButtonDown);
      
	Editar.setText ("Edit");
      
	QueuesButtonsPanel.add (Editar);
      
	QueuesButtonsAndLabelPanel.add (QueuesButtonsPanel);
    
	QueuesPanel.add (QueuesButtonsAndLabelPanel, java.awt.BorderLayout.NORTH);
  
	QueuesTableAndStatisticsPanelPanel.setLayout (new java.awt.BorderLayout ());
	QueuesTable.setModel (pushQueueModel);
      
	QueuesTableScrollPane.setViewportView (QueuesTable);

	QueuesTable.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
      
	QueuesTableAndStatisticsPanelPanel.add (QueuesTableScrollPane, java.awt.BorderLayout.CENTER);
    
	StatiscsPanel.setLayout (new java.awt.GridLayout (1, 4));
    
	TreeConections.setText ("Tree Conections:");
      
	StatiscsPanel.add (TreeConections);
      
	P2PConections.setText ("P2P Conections");
      
	StatiscsPanel.add (P2PConections);
      
	DownloadSpeed.setText ("Download Speed:");
      
	StatiscsPanel.add (DownloadSpeed);
      
	UploadSpeed.setText ("Upload Speed:");
      
	StatiscsPanel.add (UploadSpeed);
      
	QueuesTableAndStatisticsPanelPanel.add (StatiscsPanel, java.awt.BorderLayout.SOUTH);
    
	QueuesPanel.add (QueuesTableAndStatisticsPanelPanel, java.awt.BorderLayout.CENTER);
  

        getContentPane ().add (QueuesPanel);

        setJMenuBar (MainMenuBar);

    }//GEN-END:initComponents

    private void ConectionsActionPerformed (java.awt.event.ActionEvent evt) {

    }

    private void MoveUpActionPerformed (java.awt.event.ActionEvent evt) {

	//************* CHAMA A FUNO UP DO MODEL ***************** 
	pushQueueModel.moveUp(QueuesTable.getSelectedRow());

    }

    private void ButtonLessActionPerformed (java.awt.event.ActionEvent evt) {

	if (javax.swing.JOptionPane.showConfirmDialog (null, "Are you sure you want to remove these files?",
						       "", javax.swing.JOptionPane.YES_NO_OPTION) != 1) {
	    // ************ CHAMA A FUNO REMOVE DO MODEL *********
	    pushQueueModel.remove(QueuesTable.getSelectedRow());
	
	}
    }

    private void AddActionPerformed (java.awt.event.ActionEvent evt) {

	addToQueue.clear();
	addToQueue.show();
        
    
    }

    private void ButtonDownActionPerformed (java.awt.event.ActionEvent evt) {
    
	// ************ CHAMA A FUNO DOWN DO MODEL *********
	pushQueueModel.moveDown(QueuesTable.getSelectedRow());
    }

    private void ButtonUpActionPerformed (java.awt.event.ActionEvent evt) {

	// ************ CHAMA A FUNO UP DO MODEL *********
	pushQueueModel.moveUp(QueuesTable.getSelectedRow());
    
    }

    private void ButtonPlusActionPerformed (java.awt.event.ActionEvent evt) {

	addToQueue.clear();
	addToQueue.show();   
    }

    private void FiltersButtonActionPerformed (java.awt.event.ActionEvent evt) {
	if (!filtersWindow.isShowing()) {
	    filtersWindow = new FiltersWindow(conf);
	    filtersWindow.show();
	}
    }

    private void ConfigurationActionPerformed (java.awt.event.ActionEvent evt) {

    }

    private void HelpActionPerformed (java.awt.event.ActionEvent evt) {

    }

    private void DisconectMenuActionPerformed (java.awt.event.ActionEvent evt) {

	// ************ CHAMA A FUNO DisCONECT DO MODEL *********
	uiController.disconnect();
    }

    private void ConectMenuActionPerformed (java.awt.event.ActionEvent evt) {
	// ************ CHAMA A FUNO CONECT DO MODEL *********
	uiController.connect();
    }

    private void ExitActionPerformed (java.awt.event.ActionEvent evt) {

	if (javax.swing.JOptionPane.showConfirmDialog(null, "Are you sure you want to exit?",
						      "", javax.swing.JOptionPane.YES_NO_OPTION) != 1) {
	    uiController.exit();
	    System.exit(1);
        
	}
    }

    private void jMenuItem10ActionPerformed (java.awt.event.ActionEvent evt) {
	// ****** EDIT ***************
      
    }

    private void jMenuItem9ActionPerformed (java.awt.event.ActionEvent evt) {

	// ************ CHAMA A FUNO DOWN DO MODEL *********
	pushQueueModel.moveDown (QueuesTable.getSelectedRow());
    }

    private void jMenuItem7ActionPerformed (java.awt.event.ActionEvent evt) {

	// ************ CHAMA A FUNO CLEAR QUEUE DO MODEL *********
    }


    private void jMenuItem6ActionPerformed (java.awt.event.ActionEvent evt) {

	if (javax.swing.JOptionPane.showConfirmDialog(null, "Are you sure you want to remove these files?",
						      "", javax.swing.JOptionPane.YES_NO_OPTION) != 1) {
	    // ************ CHAMA A FUNO REMOVE DO MODEL *********
	    pushQueueModel.remove(QueuesTable.getSelectedRow());
	}
    }


    private void jButton4ActionPerformed (java.awt.event.ActionEvent evt) {
	// *********************** CHAMA A FUNO disCONECT *********************
	uiController.disconnect();  
    }


    private void jButton3ActionPerformed (java.awt.event.ActionEvent evt) {
	// *********************** CHAMA A FUNO CONECT **************************
	uiController.connect();
    }

    private void jMenu4ActionPerformed (java.awt.event.ActionEvent evt) {
	if (!filtersWindow.isShowing()) {	
	    filtersWindow = new FiltersWindow(conf);
	    filtersWindow.show();
	}
    }


    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {

        if (javax.swing.JOptionPane.showConfirmDialog(null, "Are you sure you want to exit?",
						      "", javax.swing.JOptionPane.YES_NO_OPTION) != 1) {
	    uiController.exit();
            System.exit(1);
        }
     
    }

    /**
     * @param args the command line arguments
     */
    public static void main (String args[]) {
        
    }

    
    /**
     * @param number the number of Tree Conections
     */
    public void setTreeConections (int number) {
	TreeConections.setText ("TreeConections: "+number);      
       
    }
    
    
    /**
     * @param number the number of P2P Conections
     */
    public void setP2PConections (int number) {
	P2PConections.setText ("P2PConections: "+number);      
       
    }
    
    
    /**
     * @param speed the Download Speed 
     */
    public void setDownloadSpeed (int speed) {
        DownloadSpeed.setText ("DownloadSpeed: "+speed+" Kb");
                
    }
    
   
    /**
     * @param speed the Upload Speed 
     */
    public void setUploadSpeed (int speed) {
        UploadSpeed.setText ("UploadSpeed: "+speed+" Kb");
                
    }
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuBar MainMenuBar;
    private javax.swing.JMenu Conections;
    private javax.swing.JMenuItem ConectMenu;
    private javax.swing.JMenuItem DisconectMenu;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JMenuItem P2PConectionsMenu;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JMenuItem Exit;
    private javax.swing.JMenu Queue;
    private javax.swing.JMenuItem Add;
    private javax.swing.JMenuItem Remove;
    private javax.swing.JMenuItem Clear;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JMenuItem MoveUp;
    private javax.swing.JMenuItem MoveDown;
    private javax.swing.JSeparator jSeparator4;
    private javax.swing.JMenuItem Edit;
    private javax.swing.JMenu Configuration;
    private javax.swing.JMenu Filters;
    private javax.swing.JMenu Help;
    private javax.swing.JPanel TransfersPanel;
    private javax.swing.JPanel ButtonsPanel;
    private javax.swing.JButton Conect;
    private javax.swing.JButton Disconect;
    private javax.swing.JButton FiltersButton;
    private javax.swing.JButton ConfigurationButton;
    private javax.swing.JButton P2PConectionsButton;
    private javax.swing.JPanel FileTransfersAndTransfersTablePane;
    private javax.swing.JLabel FileTransfers;
    private javax.swing.JScrollPane TransfersTableScrollPane;
    private javax.swing.JTable TransfersTable;
    private javax.swing.JPanel QueuesPanel;
    private javax.swing.JPanel QueuesButtonsAndLabelPanel;
    private javax.swing.JLabel PushQueue;
    private javax.swing.JPanel QueuesButtonsPanel;
    private javax.swing.JButton ButtonPlus;
    private javax.swing.JButton ButtonLess;
    private javax.swing.JButton ButtonUp;
    private javax.swing.JButton ButtonDown;
    private javax.swing.JButton Editar;
    private javax.swing.JPanel QueuesTableAndStatisticsPanelPanel;
    private javax.swing.JScrollPane QueuesTableScrollPane;
    private javax.swing.JTable QueuesTable;
    private javax.swing.JPanel StatiscsPanel;
    private javax.swing.JLabel TreeConections;
    private javax.swing.JLabel P2PConections;
    private javax.swing.JLabel DownloadSpeed;
    private javax.swing.JLabel UploadSpeed;
    // End of variables declaration//GEN-END:variables

    }
