package tcbnet.io;

import java.io.FileNotFoundException;
import java.io.IOException;

/**
 * <p>Title: TCBnet</p>
 * <p>Description: p2p content push</p>
 * <p>Copyright: TCB inc Copyright (c) 2002</p>
 * <p>Company: TCB inc</p>
 * @author $Author: fernandopeinado $
 * @version $Revision: 1.3 $
 */

public interface FileReader extends Reader {
  /**
   * Abre o arquivo pelo seu nome com permisso de leitura
   * @param fileName o nome do arquivo
   * @throws FileNotFoundException
   */
  public void openFile(String fileName) throws FileNotFoundException ;

  /**
   * Devolve o tamanho do arquivo em bytes
   * @return long fileSize
   * @exception IOException
   */
  public long getFileSize() throws IOException ;

  /**
   * Reinicia a transmisso do arquivo
   * @exception IOException
   */
  public void resetFile() throws IOException;

  /**
   * Reinicia a transmisso do arquivo para uma posio escolhida
   * @param pos a posio escolhida
   * @exception IOException
   */
  public void resetFile(long pos) throws IOException;

  /**
   * define se o arquivo chegou ao fim
   * @return true ou false
   * @exception IOException
   */
  public boolean eof() throws IOException;
}