package tcbnet.io;

/**
 * <p>Title: TCBnet</p>
 * <p>Description: p2p content push</p>
 * <p>Copyright: TCB inc Copyright (c) 2002</p>
 * <p>Company: TCB inc</p>
 * @author $Author: fernandopeinado $
 * @version $Revision: 1.5 $
 */

public class FileReaderTail extends FileReaderImpl {
  public static final int SLEEP_TIME = 1000;
  protected long originalFileSize;

  /**
   * Construtor padro
   */
  public FileReaderTail() {
    super();
    originalFileSize = 0;
  }

  /**
   * Seta o tamanho original do arquivo. Necessrio para se testar se um
   * aviso de EOF realmente significa o fim do arquivo, ou se o restante
   * do arquivo ainda no est disponvel.
   * @param size o tamanho do arquivo completo
   */
  public void setOriginalSize(long size) {
    this.originalFileSize = size;
  }

  /**
   * Devolve o tamanho do arquivo original. O tamanho que o arquivo deve possuir
   * quando estiver completo.
   * @return o tamanho do arquivo original
   */
  public long getOriginalSize() {
    return this.originalFileSize;
  }

  /**
   * L um bloco caso ele esteja disponvel, se no espera at que ele esteja.
   * @return o bloco lido
   * @throws IOException caso ocorra algum erro na leitura
   */
  public byte[] readBuffer() throws java.io.IOException {
      while (this.eof() && this.getFileSize() < this.originalFileSize)
	  try {
	      Thread.sleep(FileReaderTail.SLEEP_TIME);
	  } catch (InterruptedException ie) { }
      return super.readBuffer();
  }
}
