package tcbnet.io;

import java.io.FileNotFoundException;
import java.io.IOException;

/**
 * <p>Title: TCBnet</p>
 * <p>Description: p2p content push</p>
 * <p>Copyright: TCB inc Copyright (c) 2002</p>
 * <p>Company: TCB inc</p>
 * @author $Author: fernandopeinado $
 * @version $Revision: 1.8 $
 */

public interface FileWriter {
  /**
   * Abre um arquivo para a escrita pelo seu nome
   * @param fileName o nome do arquivo de destino
   * @exceptiom FileNotFound caso ocorra algum erro na abertura de um arquivo
   *            que j existia (permissoes, diretrio, outros...)
   */
  public void openFile(String fileName) throws FileNotFoundException;

  /**
   * Escreve um buffer com um segmento do arquivo
   * @param byte[] contendo o buffer a ser escrito
   * @throws IOException
   */
  public void writeBuffer(byte[] array) throws IOException;

  public void closeFile() throws IOException;
}
