package tcbnet.io;

import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

/**
 * <p>Title: TCBnet</p>
 * <p>Description: p2p content push</p>
 * <p>Copyright: TCB inc Copyright (c) 2002</p>
 * <p>Company: TCB inc</p>
 * @author $Author: rcouto $
 * @version $Revision: 1.10 $
 */

public class FileWriterImpl implements FileWriter {
  private FileOutputStream file;

  /**
   * Construtor padro
   */
  public FileWriterImpl() { }

  /**
   * Abre um arquivo para a escrita pelo seu nome
   * @param fileName o nome do arquivo de destino
   * @exceptiom FileNotFound caso ocorra algum erro na abertura de um arquivo
   *            que j existia (permissoes, diretrio, outros...)
   */
  public void openFile(String fileName) throws FileNotFoundException {
    this.file = new FileOutputStream(fileName);
  }

  /**
   * Escreve um buffer com um segmento do arquivo
   * @param array contendo o buffer a ser escrito
   * @throws IOException
   */
  public void writeBuffer(byte[] array) throws IOException {
    this.file.write(array);
    this.file.flush();
  }

  /**
   * Fecha um arquivo
   */
  public void closeFile() throws IOException {
    this.file.close();
  }
}



