package tcbnet.io;

import java.io.*;

/**
 * <p>Title: TCBnet</p>
 * <p>Description: p2p content push</p>
 * <p>Copyright: TCB inc Copyright (c) 2002</p>
 * <p>Company: TCB inc</p>
 * @author $Author: fernandopeinado $
 * @version $Revision: 1.4 $
 */

public class ObjectFile {
  /**
   * Grava um objeto serializavel em um arquivo com um nome especificado
   * @param filename o nome do arquivo
   * @param obj o objeto a ser escrito no arquivo
   * @throws IOException caso ocorra algum erro de IO
   */
  public static void saveObject(String filename, Object obj)
    throws IOException {

    ObjectOutputStream out =
      new ObjectOutputStream(
        new FileOutputStream(filename));

    out.writeObject(obj);
  }

  /**
   * Carrega um objeto de um arquivo especificado
   * @param filename o arquivo
   * @return o Objeto carregado
   * @exception IOException caso ocorra algum erro de IO
   * @exception ClassNotFoundException caso a classe do objeto que est
   *            no arquivo no seja encontrada
   */
  public static Object loadObject(String filename)
    throws IOException, ClassNotFoundException {

    ObjectInputStream in =
      new ObjectInputStream(
        new FileInputStream(filename));

    return in.readObject();
  }
}

