package tcbnet.treecast;

import java.io.*;
import tcbnet.corba.*;

/**
 * Interface de utilizacao de Treecasts.
 *
 * @author $Author: rcouto $
 * @version $Revision: 1.11 $
 */
public interface Treecast {

    /**
     * Comeca aceitar pedidos de Stream
     */
    public void start ();

    /**
     * Para de aceitar pedidos de Stream.
     */
    public void stop ();

    /**
     * Retorna uma Stream do arquivo transmitido.
     *
     * @param n Node que quer a Stream.
     * @return Stream do arquivo transmitido.
     * @throws NoStreamAvailableException
     * @throws NotAvailableException
     */
    public Stream getStream (Node n)
	throws NoStreamAvailableException, NotAvailableException;

    /**
     * @return o Header que o Treecast esta transmitindo.
     */
    public Header getHeader ();

    /**
     * @return o numero de Streams ativas do Treecast.
     */
    public int getStreamCount ();

    /**
     * @return o numero de Streams jah completadas do Treecast.
     */
    public int getStreamDoneCount ();
}
