package tcbnet.util;

import java.util.ArrayList;

/**
 * Implementa uma fila (FIFO) thread-safe.
 *
 * @author $Author: fernandopeinado $
 * @version $Revision: 1.8 $
 */
public class Queue {

    private ArrayList list;

    /**
     * Construtor.
     */
    public Queue () {
	this.list = new ArrayList ();
    }

    /**
     * Adiciona cada item da Array no final da fila, respectivamente.
     *
     * @param o Array de Objetos a serem adicionador
     */
    public synchronized void addAll (Object[] o) {
	for (int i = 0; i < o.length; i++)
	    this.add (o[i]);
    }

    /**
     * Adiciona um Object no final da fila.
     *
     * @param o Objeto a ser adicionado.
     */
    public synchronized void add (Object o) {
	this.list.add (o);
    }

    /**
     * Remove o primeiro Object da fila.
     *
     * @return Object removido do comeco da fila.
     */
    public synchronized Object remove () {
	if (this.list.size() == 0) return null;
	return this.list.remove (0);
    }

    /**
     * Retorna se a fila esta vazia.
     *
     * @return Se a fila esta vazia
     */
    public synchronized boolean isEmpty () {
	return this.list.isEmpty ();
    }
}
